unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Bt_AvecTMemoryStream: TButton;
    MemoFileVueInput: TMemo;
    Panel1: TPanel;
    OpenDialog: TOpenDialog;
    Panel2: TPanel;
    Splitter1: TSplitter;
    MemoFileMem: TMemo;
    MemoFileModifie: TMemo;
    Panel3: TPanel;
    Splitter2: TSplitter;
    Bt_AvecTFileStream: TButton;
    SaveDialog1: TSaveDialog;
    Bt_TStringSTream: TButton;
    procedure Bt_AvecTMemoryStreamClick(Sender: TObject);
    procedure Bt_AvecTFileStreamClick(Sender: TObject);
    procedure Bt_TStringSTreamClick(Sender: TObject);
  private
    { Dclarations prives }
   procedure MiseEnFormeTxt( Var VFileInput : TStrings );
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure TForm1.MiseEnFormeTxt( Var VFileInput : TStrings );
var
  VRow 		: Integer 		;
  VFileDump 	: TstringList   	;
  VLigne	: String 		;
begin
 VFileDump 	 := TStringList.create ;
 For Vrow :=0 to VFileInput.Count-1 do
 begin
  if (pos('#',VFileInput.Strings[Vrow])=1 ) and (length(VFileInput.Strings[VRow])>1 )then
  begin
   VLigne := VFileInput.Strings[Vrow];
   VFileDump.Add('#');
   delete(Vligne,1,1);
   VFileDump.Add(trim(VLigne));
  end
  else
   VFileDump.Add(VFileInput.Strings[Vrow]);
 end ;
   VFileInput.Clear ;
   VFileInput.Assign(VFileDump);
  VFileDump.Free ;
end;

procedure TForm1.Bt_AvecTMemoryStreamClick(Sender: TObject);
 Var
   VFileTxt : TStrings   	;
   VFileMem : TMemoryStream ;

begin
  VFiletxt   := TStringList.Create ;
  VFileMem   := TMemoryStream.Create ;
  OpenDialog.InitialDir:=ExtractfilePath(Application.ExeName);
  OpenDialog.Title := 'Chargement Fichier Brut' ;

  if OpenDialog.Execute then
  begin
   VFileTxt.LoadFromFile(Opendialog.FileName);
   MemoFileVueInput.Lines.Clear ;
   MemoFileVueInput.Lines.Add('Visuel fichier texte import');
   MemoFileVueInput.Lines.AddStrings(VFileTxt);

   MiseEnFormeTxt(VFileTxt);

   MemoFileModifie.Lines.Clear;
   MemoFileModifie.Lines.Add('Controle visuel modification fichier');
   MemoFileModifie.Lines.AddStrings(VFileTxt);

   VFileTxt.SaveToStream(VFileMem);

   MemoFileMem.Lines.Clear ;
   MemoFileMem.Lines.LoadFromStream(VFileMem);

   VFileMem.SaveToFile('VFileMem_MemoryStream.TXT');
   VFileTxt.Free ;
   VFileMem.Free ;
  end
else
 exit;
end;


procedure TForm1.Bt_AvecTFileStreamClick(Sender: TObject);
 Var
   VFileTxt : TStrings   	;
   VFileMem : TFileStream	;


begin
  VFiletxt   := TStringList.Create ;
  VFileMem   := TFileStream.Create('TFileStream.Txt',fmCreate) ;
  OpenDialog.InitialDir:=ExtractfilePath(Application.ExeName);
  OpenDialog.Title := 'Chargement Fichier Brut' ;

  if OpenDialog.Execute then
  begin
   VFileTxt.LoadFromFile(Opendialog.FileName);
   MemoFileVueInput.Lines.Clear ;
   MemoFileVueInput.Lines.Add('Visuel fichier texte import');
   MemoFileVueInput.Lines.AddStrings(VFileTxt);

    MiseEnFormeTxt(VFileTxt);

   MemoFileModifie.Lines.Clear;
   MemoFileModifie.Lines.Add('Controle visuel modification fichier');
   MemoFileModifie.Lines.AddStrings(VFileTxt);

    VFileTxt.SaveToStream(VFileMem);

    MemoFileMem.Lines.Clear ;
    MemoFileMem.Lines.LoadFromStream(VFileMem);

    VFileTxt.Free ;
    VFileMem.Free ;
  end
else
exit;
end;




procedure TForm1.Bt_TStringSTreamClick(Sender: TObject);
 Var
   VFileTxt : TStrings   	;
   VFileMem : TStringStream	;


begin
  VFiletxt   := TStringList.Create ;
  VFileMem   := TStringStream.Create('TStringStream.Txt') ;
  OpenDialog.InitialDir:=ExtractfilePath(Application.ExeName);
  OpenDialog.Title := 'Chargement Fichier Brut' ;

  if OpenDialog.Execute then
  begin
   VFileTxt.LoadFromFile(Opendialog.FileName);
   MemoFileVueInput.Lines.Clear ;
   MemoFileVueInput.Lines.Add('Visuel fichier texte import');
   MemoFileVueInput.Lines.AddStrings(VFileTxt);

    MiseEnFormeTxt(VFileTxt);

   MemoFileModifie.Lines.Clear;
   MemoFileModifie.Lines.Add('Controle visuel modification fichier');
   MemoFileModifie.Lines.AddStrings(VFileTxt);

    VFileTxt.SaveToStream(VFileMem);

    MemoFileMem.Lines.Clear ;
    MemoFileMem.Lines.LoadFromStream(VFileMem);
 
     VfileTxt.Free ;
    VFileMem.Free ;
  end
else
exit;
end;


end.
